// index-builder.js - code to build XUL trees (and HTML items).
// Needs refactoring.
// $Header: /cvs/archangel/src/archangel/content/index-builder.js,v 1.9 2003/02/12 03:01:55 marnanel Exp $
//
// Copyright (c) 2002 Thomas Thurman
// thomas@thurman.org.uk
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have be able to view the GNU General Public License at 
// http://www.gnu.org/copyleft/gpl.html ; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.

////////////////////////////////////////////////////////////////
//
// Code to modify the index tree.

// Adds a row to the index.
// |celltexts|[0] is the CSS style for the row.
// The remainder of |celltexts| is the cell contents.
function addToIndex(celltexts) {

	var props = celltexts[0];

	function cell(text) {
		var c = document.createElement('treecell');
		c.setAttribute('label', text);
		c.setAttribute('properties',props);
		return c;
	}

	var holder = document.getElementById('groggs-items');
	var item = document.createElement('treeitem');
	var row = document.createElement('treerow');

	for (var i=1; i<celltexts.length; i++)
		row.appendChild(cell(celltexts[i]));

	item.appendChild(row);

	holder.appendChild(item);
}

////////////////////////////////////////////////////////////////
//
// Code to modify the HTML item display

var itemWindow = 0;
var itemHolder = 0;

function assignHolder() {
	itemWindow = frames[0].document;
	itemHolder = itemWindow.getElementById('edits');
}

function clearItemLines() {

	assignHolder();

	while (itemHolder.hasChildNodes()) 
		itemHolder.removeChild(itemHolder.lastChild);
}

http_url = /(http:\/\/[A-Za-z0-9_+~#\/?%.,&-]*)/;

// Whether we're reformatting the text. At present, we always do.
reformatting = 1;

function addItemLine(line) {

	var temp = line;
	var where = 0;

	assignHolder();

	do {

		where = temp.search(http_url);

		if (where==-1) {
			itemHolder.appendChild(itemWindow.createTextNode(temp));
		} else {
			var target_url = RegExp.$1;
			var link = itemWindow.createElement('a');

			itemHolder.appendChild(itemWindow.createTextNode(temp.substring(0, where)));

			link.setAttribute('href', target_url);
			link.setAttribute('target', '_blank'); // for everyone's sanity
			link.appendChild(itemWindow.createTextNode(target_url));
			itemHolder.appendChild(link);

			temp = temp.substring(where+target_url.length);
		}

	} while (where!=-1);

	if (reformatting) {
		// Never use newlines, unless the original was an empty line,
		// in which case we need to add a paragraph break.

		if (line=='') {
			itemHolder.appendChild(itemWindow.createElement('p'));
		} else {
			// Other newlines get replaced with spaces.
			itemHolder.appendChild(itemWindow.createTextNode(' '));
		}

	} else {
		// Add one newline
		itemHolder.appendChild(itemWindow.createElement('br'));
	}
}

function addAttributionBlock(details) {

	assignHolder();

	var div = itemWindow.createElement('div');
	div.setAttribute('class', 'attribution');

	for (var i=0; i<details.length; i++) {
		div.appendChild(itemWindow.createTextNode(details[i]));
		div.appendChild(itemWindow.createElement('br'));
	}

	itemHolder.appendChild(div);
}

function setContinueBlock(continued, subject, arrowOnRight) {
	assignHolder();

	var bucket = itemWindow.createElement('div');
	bucket.setAttribute('class','cont');
	if (arrowOnRight) bucket.setAttribute('align','right');

	var arrow = itemWindow.createElement('img');
	arrow.setAttribute('align','center');
	arrow.setAttribute('border','0');
	arrow.setAttribute('src','chrome://archangel/content/'+
		(arrowOnRight?'next':'previous') + '.png');

	var cite = itemWindow.createElement('cite');
	cite.appendChild(itemWindow.createTextNode(subject));
	
	if (!arrowOnRight) bucket.appendChild(arrow);
	bucket.appendChild(itemWindow.createTextNode(continued));
	bucket.appendChild(cite);
	if (arrowOnRight) bucket.appendChild(arrow);

	itemHolder.appendChild(bucket);
}

////////////////////////////////////////////////////////////////
//
// Code to modify the status bar at the foot of the page

function setStatus(s) {
	document.getElementById('statusMessage').setAttribute('value',s);
}
 
function stripyMeter(message) {
	document.getElementById('progress').
		setAttribute('mode', 'undetermined');
	setStatus(message);
}

function calmMeter() {
	document.getElementById('progress').
		setAttribute('mode', 'determined');
	setStatus('Ready');
}

// eof index-builder.js


